﻿using System;
using System.Reflection;
using Coffee.Configuration;

namespace Coffee.ServiceLocators
{
    public delegate object ValueConverterDelegate(object value);

    public class ValueConverterService : ServiceLocator<Type, ValueConverterDelegate>
    {
        public static void Initialize()
        {
            ProvidersSection config = ProvidersSection.GetConfiguration("Coffee/ConverterProviders");
            if (config != null)
            {
                foreach (KeyTypeMethodElement item in config.Providers)
                {
                    Type t = Type.GetType(item.Type);
                    MethodInfo mi = t.GetMethod(item.Method);
                    AddProvider(Type.GetType(item.Key), (ValueConverterDelegate)Delegate.CreateDelegate(typeof(ValueConverterDelegate), mi));
                }
            }
        }
    }
}
