﻿/* 
 * This file is part of the Coffee Survey Framework - http://coffee.codeplex.com
 */
using System.Text;
using System.Web.UI.WebControls;
using System.Data;


namespace Coffee.Utils
{
    public class XmlNodeListMapper : DataBoundControl
    {
        string textfield, valuefield;
        StringBuilder sb = new StringBuilder();
        object datasource;

        public string DataTextField { get { return textfield; } set { textfield = value; } }
        public string DataValueField { get { return valuefield; } set { valuefield = value; } }
        public override object DataSource { get { return datasource; } set { datasource = value; } }

        /// <summary>
        /// Build the XML string from the data
        /// </summary>
        public override void DataBind()
        {
            DataTable dt = (DataTable)datasource;
            sb.Append("<table>");
            if (dt != null)
            {
                foreach (DataRow dr in dt.Rows)
                {
                    sb.Append(string.Format("<row><text>{0}</text><value>{1}</value></row>", dr[textfield].ToString(), dr[valuefield].ToString()));
                }
            }
            sb.Append("</table>");
        }

        public override string ToString()
        {
            return sb.ToString();
        }
    }
}
